# coding: utf-8

#
# Copyright 2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the 'License'). You may not use this file
# except in compliance with the License. A copy of the License is located at
#
# http://aws.amazon.com/apache2.0/
#
# or in the 'license' file accompanying this file. This file is distributed on an 'AS IS' BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for
# the specific language governing permissions and limitations under the License.
#
from __future__ import absolute_import

from .version_submission_status import VersionSubmissionStatus
from .export_response import ExportResponse
from .hosted_skill_deployment_status import HostedSkillDeploymentStatus
from .instance import Instance
from .hosted_skill_provisioning_status import HostedSkillProvisioningStatus
from .image_attributes import ImageAttributes
from .validation_endpoint import ValidationEndpoint
from .clone_locale_status import CloneLocaleStatus
from .clone_locale_request import CloneLocaleRequest
from .validation_data_types import ValidationDataTypes
from .validation_failure_reason import ValidationFailureReason
from .rollback_request_status_types import RollbackRequestStatusTypes
from .create_skill_with_package_request import CreateSkillWithPackageRequest
from .skill_messaging_credentials import SkillMessagingCredentials
from .withdraw_request import WithdrawRequest
from .resource_import_status import ResourceImportStatus
from .import_response_skill import ImportResponseSkill
from .create_rollback_request import CreateRollbackRequest
from .hosted_skill_deployment_status_last_update_request import HostedSkillDeploymentStatusLastUpdateRequest
from .rollback_request_status import RollbackRequestStatus
from .clone_locale_status_response import CloneLocaleStatusResponse
from .skill_version import SkillVersion
from .skill_interaction_model_status import SkillInteractionModelStatus
from .create_rollback_response import CreateRollbackResponse
from .format import Format
from .skill_summary_apis import SkillSummaryApis
from .create_skill_response import CreateSkillResponse
from .interaction_model_last_update_request import InteractionModelLastUpdateRequest
from .ssl_certificate_payload import SSLCertificatePayload
from .export_response_skill import ExportResponseSkill
from .skill_resources_enum import SkillResourcesEnum
from .action import Action
from .build_step_name import BuildStepName
from .validation_details import ValidationDetails
from .reason import Reason
from .list_skill_response import ListSkillResponse
from .version_submission import VersionSubmission
from .hosted_skill_provisioning_last_update_request import HostedSkillProvisioningLastUpdateRequest
from .image_dimension import ImageDimension
from .image_size import ImageSize
from .validation_failure_type import ValidationFailureType
from .validation_feature import ValidationFeature
from .hosted_skill_deployment_details import HostedSkillDeploymentDetails
from .list_skill_versions_response import ListSkillVersionsResponse
from .clone_locale_stage_type import CloneLocaleStageType
from .regional_ssl_certificate import RegionalSSLCertificate
from .agreement_type import AgreementType
from .publication_method import PublicationMethod
from .clone_locale_resource_status import CloneLocaleResourceStatus
from .image_size_unit import ImageSizeUnit
from .update_skill_with_package_request import UpdateSkillWithPackageRequest
from .skill_status import SkillStatus
from .build_step import BuildStep
from .overwrite_mode import OverwriteMode
from .response_status import ResponseStatus
from .skill_credentials import SkillCredentials
from .clone_locale_request_status import CloneLocaleRequestStatus
from .build_details import BuildDetails
from .manifest_last_update_request import ManifestLastUpdateRequest
from .skill_summary import SkillSummary
from .standardized_error import StandardizedError
from .publication_status import PublicationStatus
from .create_skill_request import CreateSkillRequest
from .status import Status
from .manifest_status import ManifestStatus
from .import_response import ImportResponse
from .submit_skill_for_certification_request import SubmitSkillForCertificationRequest
from .upload_response import UploadResponse
